import { system, world } from "@minecraft/server";

const recipes = [
    {
        output: "raw_ground_beef",
        ingredients: [
            { item: "minecraft:beef", count: 1 },
        ],
    },
    {
        output: "raw_pork_ribs",
        ingredients: [
            { item: "minecraft:porkchop", count: 3 },
            { item: "minecraft:bone", count: 6 },
        ],
    },
];


const butcher_block = new Map();


function processButcherBlockInventory(entity) {
    const id = entity.id;

    if (butcher_block.get(id)?.isProcessing) {

        return;
    }

    const inventoryComponent = entity.getComponent("minecraft:inventory");

    if (!inventoryComponent || !inventoryComponent.container) {

        return;
    }

    const inventory = inventoryComponent.container;

    for (const recipe of recipes) {

        let matches = true;

        const ingredientsMap = new Map(
            recipe.ingredients.map((ingredient) => [ingredient.item, ingredient.count])
        );

        for (let i = 0; i < inventory.size; i++) {
            const item = inventory.getItem(i);
            if (item) {
                if (ingredientsMap.has(item.typeId)) {
                    const remainingCount = ingredientsMap.get(item.typeId) - item.amount;
                    if (remainingCount <= 0) {
                        ingredientsMap.delete(item.typeId);
                    } else {
                        ingredientsMap.set(item.typeId, remainingCount);
                    }
                } else {

                    matches = false;
                    break;
                }
            }
        }

        if (matches && ingredientsMap.size === 0) {
            entity.runCommandAsync("summon ww_dx:processing_particle ~ ~1 ~")

            for (const ingredient of recipe.ingredients) {
                let remainingToRemove = ingredient.count;

                for (let i = 0; i < inventory.size; i++) {
                    const item = inventory.getItem(i);
                    if (item && item.typeId === ingredient.item) {
                        if (item.amount > remainingToRemove) {
                            item.amount -= remainingToRemove;
                            inventory.setItem(i, item);
                            break;
                        } else {
                            remainingToRemove -= item.amount;
                            inventory.setItem(i, undefined);
                        }
                    }
                }
            }


            butcher_block.set(id, { isProcessing: true });
            system.runTimeout(() => {
                if (!entity.isValid()) return;
                const { x, y, z } = entity.location;
                entity.runCommandAsync(`loot spawn ${x} ${y + 1} ${z} loot ${recipe.output}`);
                entity.runCommandAsync("event entity @e[type=ww_dx:processing_particle,r=1] ww_dx:despawn")
                entity.runCommandAsync("playsound ww_dx:finish_cooking @a[r=5]")

                butcher_block.set(id, { isProcessing: false });
            }, 200);

            return;
        } else {

        }
    }


}
let worldInitialize = false;
world.afterEvents.playerSpawn.subscribe((event) => {
    worldInitialize = true;

})
function checkButcherBlock() {
    if (!worldInitialize) {
        return
    }
    const currentDimension = world.getDimension(world.getPlayers()[0].dimension.id);

    for (const entity of currentDimension.getEntities()) {
        if (entity.typeId === "ww_dx:butcher_block") {
            if (!butcher_block.has(entity.id)) {
                butcher_block.set(entity.id, { isProcessing: false });

            }

            processButcherBlockInventory(entity);
        }
    }
}

system.runInterval(() => {
    checkButcherBlock();
}, 20); 
